# Binary Editor - BinEditor Widget Demo Program
#
# Copyright (c) 2006 OHTSUKA, Yoshio
# This program is free to use, modify, extend at will. The author(s)
# provides no warrantees, guarantees or any responsibility for usage.
# Redistributions in any form must retain this copyright notice.
# ohtsuka.yoshio@gmail.com

lappend auto_path ..
package require Tk
package require Bineditor

# Menu
menu .mbar -border 0 -tearoff 0
.mbar add cascade -label File -menu [menu .mbar.file]
.mbar.file add command -label Open... -command {openFile}
.mbar.file add command -label Save... -command {saveFile}
.mbar.file add command -label Close   -command {closeFile}
.mbar.file add separator
.mbar.file add command -label Exit    -command exit
. configure -menu .mbar

# Widgets
scrollbar .y \
	-command ".bin yview"

bineditor::bineditor .bin \
	-height 15 \
	-yscrollcommand ".y set"

pack .y -fill y -side right
pack .bin -fill both -expand yes

# Event
bind .bin <<Cursor>> {puts MOVE:[%W offset cursor]}

# Menu Commands
proc openFile {} {
	set file [tk_getOpenFile -parent .]
	if {![file exists $file]} {bell; return}
	cd [file dir $file]

	set st [clock clicks -milli]
	set fp [open $file r]
	fconfigure $fp -translation binary -encoding binary
	set data [read $fp]
	close $fp
	.bin set $data
	set ed [clock clicks -milli]
	puts open\ time:[expr ($ed - $st) / 1000.0]\ sec
}

proc saveFile {} {
	set file [tk_getSaveFile -parent .]
	if {$file eq ""} {return}

	set fp [open $file w]
	fconfigure $fp -translation binary -encoding binary
	puts -nonewline $fp [.bin get]
	close $fp
}

proc closeFile {} {
	.bin clear
}

