[manpage_begin bineditor n 1.0]
[moddesc {Binary Editor Widget}]
[titledesc {binary editor widget for Tk}]
[copyright "OHTSUKA Yoshio <ohtsuka.yoshio@gmail.com>"]
[require Tcl 8.4]
[require Tk 8.4]
[require Bineditor]


[description]
This program is binary editor widget.


[section COMMAND]
[list_begin definitions]
[call [cmd bineditor::bineditor] [arg pathName] [arg [opt {option value ...}]]]
Creates and configures a bineditor widget and return the name. 
see [sectref {WIDGET OPTION}].
[list_end]


[section {WIDGET OPTION}]
[list_begin opt]
[opt_def -background] Background color.
[opt_def -bg        ] Alias of [option -background]
[opt_def -cursorbg  ] Cursor background color.
[opt_def -cursorfg  ] Cursor foreground color.
[opt_def -encoding  ] Encoding of Ascii edit field.
[opt_def -fg        ] Alias of [option -foreground]
[opt_def -foreground] Foreground color.
[opt_def -headerbg  ] Header foreground color.
[opt_def -headerfg  ] Header background color.
[opt_def -height    ] Line number of data.
[opt_def -insertmode] Cursor insert mode. [arg insert] or [arg overwrite]
[opt_def -selectbg  ] Selection range background color.
[opt_def -selectfg  ] Selection range foreground color.
[list_end]


[section {WIDGET COMMAND}]
[list_begin definitions]
[call [arg pathName] [method cget] [arg option]]
Return the current value of the configuration option given by option.
see [sectref {WIDGET OPTION}].
[call [arg pathName] [method clear]]
Clear all.
[call [arg pathName] [method configure] [arg [opt "option value ..."]]]
Query or modify the configuration options of the widget.
see [sectref {WIDGET OPTION}].
[call [arg pathName] [method get] [arg [opt offset1]] [arg [opt offset2]]]
If offset1 and offset2 were omitted, return all bytearray data.
If offset2 was omitted, return a byte data at offset1.
[call [arg pathName] [method insert] [arg offset] [arg data]]
Insert [arg data] at the positon of [arg offset].
[arg data] must be bytearray.
[call [arg pathName] [method movecursor] [arg offset]]
Move cursor to [arg offset].
[call [arg pathName] [method offset] [arg mark]]
Return the offset of [arg mark]. mark is one of the cursor, last, sel.first or sel.last.
[call [arg pathName] [method overwrite] [arg offset] [arg data]]
Overwrite by [arg data] at the positon of [arg offset].
[arg data] must be bytearray.
[call [arg pathName] [method see] [arg offset]]
If offset position is hidden, show it.
[call [arg pathName] [method "selection get"]]
Return a list of selection range. the elements are offset of binary.
[call [arg pathName] [method "selection set"] [arg offset1] [arg offset2]]
Set a selection range. [arg offset1] and [arg offset2] are offset of binary.
[call [arg pathName] [method set] [arg data]]
Set binary data. [arg data] must be bytearray.
[call [arg pathName] [method yview] [arg [opt args]]]
This command is used to query and change the vertical position.
[list_end]


[section {VIRTUAL EVENT}]
<<Cursor>> virtual event is generated after widget cursor was moved.


[section EXAMPLE]
[example_begin]
pacakge require Tk
package require Bineditor

scrollbar .y -command ".bin yview"
bineditor::bineditor .bin -height 15 -yscrollcommand ".y set"

pack .y -fill y -side right
pack .bin -fill both -expand yes
[example_end]

[section LICENSE]
BSD-Style

[keywords binary]
[manpage_end]
